var util = require("util");
var assert = require("assert");



var base = require('./ContextBase');
module.exports = (function(target){

	util.inherits(target, base);

	target.prototype.echo = function(data, state){
		if(state.useFilter){
			if(state.atEnd){
				this.parent.echo('end(' + JSON.stringify(data) + ');', {});
			}
			else{
				this.parent.echo('write(' + JSON.stringify(data) + ');', {});
			}
		}
		else{
			this.parent.echo(data, {});
		}
	}

	target.prototype.categories = [
		"tagComment"
		, "anchor"
	];

	target.prototype.onToken = function(token){
		var AnchorContext = require('./AnchorContext');
		
		switch(token.category){
			case 'tagComment':
			this.echo('/*' + token[1] + '*/\n', {});
			return this;

			case 'anchor':
			return new AnchorContext(this, token);

			case null:
			return this.end(token);
		}

		return base.prototype.onToken.apply(this, arguments);
	};//onToken


	return target;

})(function(parent, beginToken){

	base.call(this, parent, beginToken);
});



